#import <Foundation/Foundation.h>
#import "AsReaderP252BProtocol.h"
#import "AsReaderP252BRfidValues.h"

#define NIBBLE_UNIT                 4
#define MIN_OFFSET                  16

@interface AsReaderP252BModule : NSObject

- (id)initWithProtocol:(AsReaderP252BProtocol *)protocol;

- (NSString *)regionName;
- (NSString *)UHFVersion;
- (NSString *)hardwareVersion;
- (NSString *)firmwareVersion;
- (AsReaderP252BMinMaxValue)powerGainRange;
- (AsReaderP252BResultCode)readMemory:(AsReaderP252BMemoryBank)bank offset:(int)offset length:(int)length;
- (AsReaderP252BResultCode)writeMemory:(AsReaderP252BMemoryBank)bank offset:(int)offset value:(NSString *)value;
- (AsReaderP252BResultCode)lock:(int)action mask:(int)mask;
- (AsReaderP252BResultCode)permaLock:(int)action mask:(int)mask;
- (AsReaderP252BResultCode)kill:(NSString *)killPassword;

- (NSArray *)getMask:(int)index;
- (void)setMask:(int)index mask:(NSString *)mask;
- (void)setMask:(int)index mask:(NSString *)mask length:(int)length;
 
- (void)clearEpcMask;
- (unsigned long long)getEpcMaskCount;
- (void)addEpcMask:(AsReaderP252BSelectMaskEPCParam *)param;
- (AsReaderP252BSelectMaskEPCParam *)getEpcMask:(int)index;

- (NSArray *)getLBTMask;
- (NSString *)getLBT;
- (void)setLBT:(NSString *)table;
@end
