#import <Foundation/Foundation.h>
#import "AsReaderP252BRfidValues.h"
#import "AsReaderP252BPacket.h"
#import "AsReaderP252BDelegate.h"

@interface AsReaderP252BProtocol : NSObject
@property (nonatomic, strong) id<AsReaderP252BDelegate> delegate;
@property (nonatomic, assign) BOOL isReportRssi;
@property (nonatomic, assign) AsReaderP252BScanMode scanMode;

- (id)initWithAsReaderP252B:(AsReaderP252B *)asrader;
- (void)disconnect;
- (AsReaderP252BCommandType)getAction;
- (NSString *)getProperty:(AsReaderP252BPropertyType)type;
- (NSString *)getProperty:(AsReaderP252BPropertyType)type withParameter:(NSString *)param;
- (AsReaderP252BResultCode)setProperty:(AsReaderP252BPropertyType)type;
- (AsReaderP252BResultCode)setProperty:(AsReaderP252BPropertyType)type withParameter:(NSString *)param;
- (AsReaderP252BResultCode)command:(AsReaderP252BCommandType)command;
- (AsReaderP252BResultCode)command:(AsReaderP252BCommandType)command withParameter:(NSString *)param;
- (AsReaderP252BResultData *)commandSync:(AsReaderP252BCommandType)command withParameter:(NSString *)param;
- (AsReaderP252BResultData *)commandBaudRateSync:(AsReaderP252BPropertyType)command withParameter:(NSString *)param;
- (void)readData:(NSData *)data;
@end
